(*
 * Wrapper Routine zum Dynamischen Laden der Newton.dll / libNewton.so
 * Implemention gültig für Version 3.14 /3.15
 *)
Unit newton_dynamic;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils;

Type

  NewtonWorld = ^Pointer;

  TNewtonWorldGetVersion = Function(): integer; cdecl;

Var
  NewtonWorldGetVersion: TNewtonWorldGetVersion = Nil;

Function LoadNewtonLib(Filename: String): Boolean;

Function UnloadNewtonLib(): Boolean;

Implementation

Uses dynlibs, LazFileUtils, lazutf8;

Var
  lib: TLibHandle = 0;

Function UnloadNewtonLib(): Boolean;
Begin
  result := true;
  If lib <> 0 Then Begin
    result := UnloadLibrary(lib);
  End;
End;

Function LoadNewtonLib(Filename: String): Boolean;
Begin
  UnloadNewtonLib; // Man weis ja nie ...
  If FileExistsUTF8(filename) Then Begin
    result := True;
    lib := LoadLibrary(utf8tosys(Filename));
    If lib = 0 Then Begin
{$IFDEF LINUX}
      writeln('Error could not load: "' + Filename + '" + invalid lib handle.');
{$ENDIF}
      result := false;
      exit;
    End;
    // *****************************************************************************************************************************
    //
    // world control functions
    //
    // *****************************************************************************************************************************
    NewtonWorldGetVersion := TNewtonWorldGetVersion(GetProcAddress(lib, 'NewtonWorldGetVersion'));
    If Not assigned(NewtonWorldGetVersion) Then Begin
      result := false;
      exit;
    End;
    // Hier gehts weiter ..
  End;
End;

End.

