Unit Unit1;

{$MODE objfpc}{$H+}

Interface

{.$DEFINE Statisch_Gelinkt}

Uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
{$IFDEF Statisch_Gelinkt}
  newton
{$ELSE}
  newton_dynamic
{$ENDIF}
  ;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure FormCloseQuery(Sender: TObject; Var CanClose: boolean);
    Procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  End;

Var
  Form1: TForm1;

Implementation

Uses Lazfileutils, lazutf8;

{$R *.lfm}

{ TForm1 }

Procedure TForm1.FormCreate(Sender: TObject);
Begin
  OpenDialog1.InitialDir := ExtractFilePath(ParamStrUTF8(0));
{$IFDEF Linux}
  OpenDialog1.DefaultExt := '.so';
{$ELSE}
  OpenDialog1.DefaultExt := '.dll';
{$ENDIF}
  label1.caption := '';
  label2.caption := 'I am a ' + inttostr(sizeof(pointer) * 8) + '-Bit application';
End;

Procedure TForm1.Button1Click(Sender: TObject);
Begin
{$IFNDEF Statisch_Gelinkt}
  If OpenDialog1.Execute Then Begin
    label1.caption := '';
    If Not LoadNewtonLib(OpenDialog1.FileName) Then Begin
      showmessage('Error unable to load Newtonlib.');
    End
    Else Begin
      label1.caption := 'Newton version : ' + FloatToStrF(NewtonWorldGetVersion() / 100, fffixed, 7, 2);
    End;
  End;
{$ELSE}
  label1.caption := 'Newton version : ' + FloatToStrF(NewtonWorldGetVersion() / 100, fffixed, 7, 2);
{$ENDIF}
End;

Procedure TForm1.Button2Click(Sender: TObject);
Begin
  label1.caption := '';
{$IFNDEF Statisch_Gelinkt}
  If Not UnloadNewtonLib() Then Begin
    showmessage('Error unable to unload Newtonlib.');
  End;
{$ENDIF}
End;

Procedure TForm1.FormCloseQuery(Sender: TObject; Var CanClose: boolean);
Begin
{$IFNDEF Statisch_Gelinkt}
  UnloadNewtonLib();
{$ENDIF}
End;

End.

